
#property copyright "mladen"
#property link      "www.forex-station.com"
#property version   "1.00"
//#property strict

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  clrSeaGreen  
#property indicator_color2  clrDeepSkyBlue
#property indicator_color3  clrDimGray
#property indicator_color4  clrPaleVioletRed
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT


extern ENUM_TIMEFRAMES    TimeFrame  = PERIOD_CURRENT;
extern int    RsiPeriod    =  10;
extern int    MinMaxPeriod =  40;
int    RsiMode    =   1;
double LevelUp      = 76.4;
double LevelDown    = 23.6;
bool   Interpolate  = false;

int History = 20000;

double rsi[];
double rsiLUp[];
double rsiLMi[];
double rsiLDn[];
double trend[];
double rsiMin[];
double rsiMax[];
double gap[];

string indicatorFileName;
bool   returnBars;


int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,rsi); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"rsi");
   SetIndexBuffer(1,rsiLUp); SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"rsiLUp");
   SetIndexBuffer(2,rsiLMi); SetIndexStyle(2,DRAW_LINE); SetIndexLabel(2,"rsiLMi");
   SetIndexBuffer(3,rsiLDn); SetIndexStyle(3,DRAW_LINE); SetIndexLabel(3,"rsiLDn");
   SetIndexBuffer(4,trend); SetIndexStyle(4,DRAW_NONE); SetIndexLabel(4,"trend");
   SetIndexBuffer(5,rsiMin); SetIndexStyle(5,DRAW_NONE); SetIndexLabel(5,"rsiMin");
   SetIndexBuffer(6,rsiMax); SetIndexStyle(6,DRAW_NONE); SetIndexLabel(6,"rsiMax");
   SetIndexBuffer(7,gap); SetIndexStyle(7,DRAW_NONE); SetIndexLabel(7,"gap");
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
      
   IndicatorShortName(timeFrameToString(TimeFrame)+" "+ indicatorFileName);
   return(0);
}
int deinit() { return(0); }


int start()
{
   int barsBack = History;
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(barsBack-counted_bars, History);
   
   if (returnBars) { rsiMin[0] = limit+1; return(0); }   
   //if (returnBars) { rsiMin[0] = MathMin(limit+1,Bars-1); return(0); }
   
   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,PRICE_TYPICAL,i);
         if (i>barsBack-RsiPeriod)
               rsi[i] = price;
         else  rsi[i] = rsi[i+1]+(2.0*MathAbs(iRsi(price,RsiPeriod,i,0,RsiMode)/100.0-0.5))*(price-rsi[i+1]);
         
         gap[i] = 0;
         if (High[i]<Low[i+1]) gap[i] = High[i]-Low[i+1];
         if (Low[i]>High[i+1]) gap[i] = Low[i]-High[i+1];
      
         double displaceup = 0;
         double displacedn = 0;
         double max        = rsi[i];
         double min        = rsi[i];
         for (int k=0; k<MinMaxPeriod; k++)
         {
            if (gap[i+k]<0) displacedn += gap[i+k];
            if (gap[i+k]>0) displaceup += gap[i+k];
            if ((rsi[i+k]+displaceup) < min) min = rsi[i+k]+displacedn;
            if ((rsi[i+k]+displacedn) > max) max = rsi[i+k]+displacedn;
         }      
                  
         rsiMin[i] = min;
         rsiMax[i] = max;
         double range = rsiMax[i]-rsiMin[i];
         rsiLDn[i] = rsiMin[i]+range*LevelDown/100.0;
         rsiLMi[i] = rsiMin[i]+range*0.5;
         rsiLUp[i] = rsiMin[i]+range*LevelUp/100.0;
         
         trend[i] = trend[i+1];
         if(rsi[i+1] > rsiLUp[i+1] && rsi[i] < rsiLUp[i]){
            trend[i] = -1;
         }else if(rsi[i+1] < rsiLDn[i+1] && rsi[i] > rsiLDn[i]){
            trend[i] = 1;
         }
         
      }      
      return(0);
   }   

   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         rsi[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,MinMaxPeriod,0,y);
         rsiLUp[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,MinMaxPeriod,1,y);
         rsiLMi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,MinMaxPeriod,2,y);
         rsiLDn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,MinMaxPeriod,3,y);
         trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,MinMaxPeriod,4,y);
         

         if (Interpolate<1 || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;
         interpolate(rsiLUp,TimeFrame,i,Interpolate);
         interpolate(rsiLMi,TimeFrame,i,Interpolate);
         interpolate(rsiLDn,TimeFrame,i,Interpolate);
         interpolate(rsi   ,TimeFrame,i,Interpolate);
   }
   return(0);
}

void interpolate(double& target[], int pTimeFrame, int i, int interpolateType)
{
      int t = iBarShift(NULL,pTimeFrame,Time[i]); 
      double y0 = target[i];
      double y1 = target[iBarShift(NULL,0,iTime(NULL,pTimeFrame,t+0))+1];
      double y2 = target[iBarShift(NULL,0,iTime(NULL,pTimeFrame,t+1))+1];
      
      int basrBack = History;
      
      datetime time = iTime(NULL,pTimeFrame,t);
      for(int n = 1; i+n < basrBack && Time[i+n] >= time; n++) continue;
      for(int k = 1; k < n; k++)
      if (interpolateType==2)
      {
         double x3 = 1.0*k/n;
         target[i+k]  = y0*(x3-1.0)*(x3-2.0)/(-1.0*(-2.0)) +  y1*(x3-0.0)*(x3-2.0)/( 1.0*(-1.0)) +  y2*(x3-0.0)*(x3-1.0)/( 2.0*( 1.0));         
      }
      else target[i+k] = target[i] + (target[i+n] - target[i])*k/n;
}

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int& method)
{
   int max = ArraySize(rsiMethodNames)-1;
   method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}


double workRsi[][13];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0)
{
   int barsBack = History;
   
   if (ArrayRange(workRsi,0)!=barsBack) ArrayResize(workRsi,barsBack);
   int z = instanceNo*13; 
   int r = barsBack-i-1;
   
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
      default:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);         

      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),barsBack-i-1,0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),barsBack-i-1,1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); } 
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);            
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
      
   } 
}

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   int barsBack = History;
   
   if (ArrayRange(workSmma,0)!= barsBack) ArrayResize(workSmma,barsBack);

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
